/*$T indentinput.cpp GC 1.140 02/11/11 10:19:12 */


/*$6
 +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
 Binh Nguyen 2011
 +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
 */


#include <iostream>
#include <vector>
#include <fstream>
#include <cstdlib>

/*
 * selection sort takes an array of numbers and just scans it until it finds the
 * best, then scans it again until it finds the next best, and so on...
 */
using namespace std;

/*
 =======================================================================================================================
 =======================================================================================================================
 */

void swap(vector<long int> &a, int i, int j)
{
	if(i != j)
	{
		/*~~~~~~~~~~~~~~~~~*/
		long int	t = a[i];
		/*~~~~~~~~~~~~~~~~~*/

		a[i] = a[j];
		a[j] = t;
	}
}

/*
 =======================================================================================================================
 =======================================================================================================================
 */
void selSort(vector<long int> &numbers)
{
	/*~~~~~~~~~~~~~~~~~~~~~~~~~~~*/
	long int	min = numbers[0];
	long int	min_index = 0;
	int			n = numbers.size();
	/*~~~~~~~~~~~~~~~~~~~~~~~~~~~*/

	for(int i = 0; i < n - 1; i++)
	{
		min = numbers[i];
		min_index = i;

		for(int j = i + 1; j < n; j++)
		{
			if(numbers[j] < min)
			{
				min = numbers[j];
				min_index = j;
			}
		}

		swap(numbers, i, min_index);
	}
}

/*
 =======================================================================================================================
 =======================================================================================================================
 */
int main(int argc, char *argv[])
{
	if(argc != 3)
	{
		cerr << "usage: " << argv[0] << " input verbose" << endl;
		return 1;
	}

	/*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/
	vector<long int>	numbers;
	unsigned int		verbose = atoi(argv[2]);
	/*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/

	/* read numbers */
	{
		/*~~~~~~~~~~~~*/
		ifstream	fin;
		/*~~~~~~~~~~~~*/

		fin.open(argv[1]);

		/*~~~~~~~~~~~~*/
		long int	num;
		/*~~~~~~~~~~~~*/

		while(fin >> num)
		{
			numbers.push_back(num);
		}

		fin.close();
	}

	/* print */
	if(verbose)
	{
		cout << "Original array " << endl;
		for(unsigned int i = 0; i < numbers.size(); ++i)
		{
			cout << "[ " << numbers[i] << "] ";
		}

		cout << endl;
	}

	selSort(numbers);

	/* print */
	if(verbose)
	{
		cout << "Original array " << endl;
		for(unsigned int i = 0; i < numbers.size(); ++i)
		{
			cout << "[ " << numbers[i] << "] ";
		}

		cout << endl;
	}

	return 0;
}
